#include <tclap/CmdLine.h>
#include <File_Archiver_Configurator.h>

using namespace inaf::oasbo::Archivers;
FileArchiverConfigurator::FileArchiverConfigurator(){
	setDestination(std::string(".tmp"));
}


FileArchiverConfigurator::FileArchiverConfigurator(int argc, char ** argv){
	try {
		TCLAP::CmdLine cmd("Usage Description WIP", ' ', "1");
		cmd.ignoreUnmatched(true);
		TCLAP::ValueArg<std::string> destination("","archDest","The destination of the archiver",false,".tmp","path to destination");
		cmd.add( destination );

		cmd.parse( argc, argv );
		setDestination(destination.getValue());
	}catch (TCLAP::ArgException &e){  // catch any exceptions
		std::cerr << "error: " << e.error() << " for arg " << e.argId() << std::endl;
		exit(EXIT_FAILURE);
	}
}

BaseArchiver * FileArchiverConfigurator::createArchiver(){
	return new FileArchiver(getDestination());
}

FileArchiver * FileArchiverConfigurator::createFileArchiver(){
	return new FileArchiver(getDestination());
}

void FileArchiverConfigurator::createFileArchiver(FileArchiver & arch){
	arch.setDest(getDestination());
}

